#!python
# -*- coding: utf-8 -*-
__version__ = "$Revision: 1.2 $"
# $Source: /home/mechanoid/projects/py/1/numpy/RCS/main.py,v $
#
#       OS : GNU/Linux 4.7.6-1-ARCH 
# COMPILER : Python 3.5.2
#
#   AUTHOR : Evgeny S. Borisov
# 
#    http://www.mechanoid.kiev.ua
#  e-mail : nn@mechanoid.kiev.ua
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 

# список из чисел
A = [ 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 20, 21, 22, 23, 24 ]
print(A)
print("- - - - - - - - - - - - - - - - - ")

import numpy as np   # подгружаем модуль numpy

A = np.asarray(A) # преобразуем список в вектор numpy
A = A.reshape(8,3) # перестраиваем вектор в матрицу  
print("shape:",A.shape) # печатаем размер матрицы
print("ndim:",A.ndim) # печатаем размерность объекта
print("size:",A.size) # печатаем размер объекта (количество элементов)
print("dtype:",A.dtype) # печатаем тип объекта 
print("itemsize:",A.itemsize,"bytes") # печатаем размер элемента в байтах
print("- - - - - - - - - - - - - - - - - ")
print(A) # печатаем содержимое матрицы

print("- - - - - - - - - - - - - - - - - ")

# B = [ 24, 23, 22, 21, 20, 19, 18, 17, 16, 15, 14, 13, 12, 11, 10, 9, 8, 7, 6, 5, 4, 3, 2, 1, 0 ]
B = np.random.rand(8,3) # генерируем матрицу  8х3 из случайных чисел 0-1
print(B.shape)
print(B)
print("- - - - - - - - - - - - - - - - - ")

C =  A.T.dot( B ) # транспонируем матрицу A и умножаем на матрицу B
print(C.shape)
print(C)

print("- - - - - - - - - - - - - - - - - ")
D = np.arange(9).reshape(3,3) # генерируем вектор целых чисел 0-8, перестраиваем его в матрицу 3х3 
print(D)

print("- - - - - - - - - - - - - - - - - ")
E = np.ones((2,3),dtype=int) # матрица из единиц 2х3
print(E)

print("- - - - - - - - - - - - - - - - - ")
n = 10
F = np.linspace(0,np.pi,n).reshape(n,1) # разделяем отрезок от 0 до Пи на n-1 равных части
print(F)

print("- - - - - - - - - - - - - - - - - ")
# система линейных уравнений
a = np.array([[1.0, 2.0], [3.0, 4.0]])
y = np.array([[5.], [7.]])
s = np.linalg.solve(a, y) # решение 
print(s)

